/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.STS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
/**
 * MergeApi - axios parameter creator
 * @export
 */
export const MergeApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string | null} [returnUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        mergeCallback: async (returnUrl?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/Merge/callback`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string | null} [returnUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        mergeLogin: async (returnUrl?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/Merge/login`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * MergeApi - functional programming interface
 * @export
 */
export const MergeApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = MergeApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string | null} [returnUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async mergeCallback(returnUrl?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.mergeCallback(returnUrl, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['MergeApi.mergeCallback']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @param {string | null} [returnUrl] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async mergeLogin(returnUrl?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.mergeLogin(returnUrl, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['MergeApi.mergeLogin']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * MergeApi - factory interface
 * @export
 */
export const MergeApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = MergeApiFp(configuration)
    return {
        /**
         * 
         * @param {MergeApiMergeCallbackRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        mergeCallback(requestParameters: MergeApiMergeCallbackRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.mergeCallback(requestParameters.returnUrl, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {MergeApiMergeLoginRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        mergeLogin(requestParameters: MergeApiMergeLoginRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.mergeLogin(requestParameters.returnUrl, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for mergeCallback operation in MergeApi.
 * @export
 * @interface MergeApiMergeCallbackRequest
 */
export interface MergeApiMergeCallbackRequest {
    /**
     * 
     * @type {string}
     * @memberof MergeApiMergeCallback
     */
    readonly returnUrl?: string | null
}

/**
 * Request parameters for mergeLogin operation in MergeApi.
 * @export
 * @interface MergeApiMergeLoginRequest
 */
export interface MergeApiMergeLoginRequest {
    /**
     * 
     * @type {string}
     * @memberof MergeApiMergeLogin
     */
    readonly returnUrl?: string | null
}

/**
 * MergeApi - object-oriented interface
 * @export
 * @class MergeApi
 * @extends {BaseAPI}
 */
export class MergeApi extends BaseAPI {
    /**
     * 
     * @param {MergeApiMergeCallbackRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MergeApi
     */
    public mergeCallback(requestParameters: MergeApiMergeCallbackRequest = {}, options?: AxiosRequestConfig) {
        return MergeApiFp(this.configuration).mergeCallback(requestParameters.returnUrl, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {MergeApiMergeLoginRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MergeApi
     */
    public mergeLogin(requestParameters: MergeApiMergeLoginRequest = {}, options?: AxiosRequestConfig) {
        return MergeApiFp(this.configuration).mergeLogin(requestParameters.returnUrl, options).then((request) => request(this.axios, this.basePath));
    }
}

